
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

/*Função Pai de Mascaras*/
function mascara(o,f){
	v_obj=o
	v_fun=f
	setTimeout("execmascara()",1)
}

/*Função que Executa os objetos*/
function execmascara(){
	v_obj.value=v_fun(v_obj.value)
}

/*Função que Determina as expressões regulares dos objetos*/
function leech(v){
	v=v.replace(/o/gi,"0")
	v=v.replace(/i/gi,"1")
	v=v.replace(/z/gi,"2")
	v=v.replace(/e/gi,"3")
	v=v.replace(/a/gi,"4")
	v=v.replace(/s/gi,"5")
	v=v.replace(/t/gi,"7")
	return v
}

/*Função que permite apenas numeros*/
function integer(v){
	return v.replace(/\D/g,"")
}

/*Função que permite apenas letras*/
function letras(v){
	v=v.replace(/[-!"#$%&'()*+,./:;<=>?@[\\\]_`{|}~]/g,"")
        v=v.replace(/\d/g,"")
	return v
}


/*Função que permite apenas letras e não permite tipos de logradouros como rua, avenida, etc. */
function logradouro(v){
	v=v.replace(/[-!"#$%&'()*+,./:;<=>?@[\\\]_`{|}~]/g,"")
        v=v.replace(/\d/g,"")
        v=v.replace(/^RUA /gi,"")
        v=v.replace(/^R\./gi,"")
        v=v.replace(/^R /gi,"")
        v=v.replace(/^AVENIDA /gi,"")
        v=v.replace(/^AV /gi,"")
        v=v.replace(/^AV\./gi,"")
        v=v.replace(/^ALAMEDA /gi,"")
        v=v.replace(/^AL /gi,"")
        v=v.replace(/^ALA /gi,"")
        v=v.replace(/^ESTRADA /gi,"")
        v=v.replace(/^EST\./gi,"")
        v=v.replace(/^EST /gi,"")
        v=v.replace(/^VIA /gi,"")
        v=v.replace(/^SERVENTIA /gi,"")
        v=v.replace(/^SERV /gi,"")
        v=v.replace(/^SERV\./gi,"")
        v=v.replace(/^TRAVESSA /gi,"")
        v=v.replace(/^TRAV /gi,"")
        v=v.replace(/^TRV /gi,"")
        v=v.replace(/^TRAV\./gi,"")
        v=v.replace(/^RODOVIA /gi,"")
        v=v.replace(/^ROD /gi,"")
        v=v.replace(/^ROD\./gi,"")
        v=v.replace(/^BC /gi,"")
        v=v.replace(/^CAM /gi,"")
        v=v.replace(/^PC /gi,"")
        v=v.replace(/^VL /gi,"")
        
	return v
}

/*Função que padroniza telefone (11) 4184-1241*/
function telefone(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/^(\d\d)(\d)/g,"($1) $2")
	v=v.replace(/(\d{4})(\d)/,"$1-$2")
        v=v.replace(/[)] [789]/g,"")
	return v
}


/*Função que padroniza celular (11) 7184-1241*/
function celular(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/^(\d\d)(\d)/g,"($1) $2")
	v=v.replace(/(\d{4})(\d)/,"$1-$2")
        v=v.replace(/[)] [^789]/g,"")
	return v
}


/*Função que permite apenas numeros, mas pode "V" no final */
function folha(v){
	v=v.replace(/(^[^0-9])/g,"")
        v=v.replace(/([^0-9]+[0-9])/g,"")

	v=v.replace(/([^0-9]){2,}/g,"$1")
        v=v.replace(/([^vV0-9])/g,"")
	return v
}

/*Função que padroniza telefone (11) 41841241*/
function telefoneCall(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/^(\d\d)(\d)/g,"($1) $2")
	return v
}

/*Função que padroniza CPF*/
function cpf(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/(\d{3})(\d)/,"$1.$2")
	v=v.replace(/(\d{3})(\d)/,"$1.$2")

	v=v.replace(/(\d{3})(\d{1,2})$/,"$1-$2")
	return v
}

/*Função que padroniza CEP*/
function cep(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/^(\d{5})(\d)/,"$1-$2")
	return v
}

/*Função que padroniza CNPJ*/
function cnpj(v){
	v=v.replace(/\D/g,"")
	v=v.replace(/^(\d{2})(\d)/,"$1.$2")
	v=v.replace(/^(\d{2})\.(\d{3})(\d)/,"$1.$2.$3")
	v=v.replace(/\.(\d{3})(\d)/,".$1/$2")
	v=v.replace(/(\d{4})(\d)/,"$1-$2")
	return v
}

/*Função que permite apenas numeros Romanos*/
function romanos(v){
	v=v.toUpperCase()             
	v=v.replace(/[^IVXLCDM]/g,"") 
	
	while(v.replace(/^M{0,4}(CM|CD|D?C{0,3})(XC|XL|L?X{0,3})(IX|IV|V?I{0,3})$/,"")!="")
		v=v.replace(/.$/,"")
	return v
}

/*Função que padroniza o Site*/
function site(v){
	v=v.replace(/^http:\/\/?/,"")
	dominio=v
	caminho=""
	if(v.indexOf("/")>-1)
		dominio=v.split("/")[0]
		caminho=v.replace(/[^\/]*/,"")
		dominio=dominio.replace(/[^\w\.\+-:@]/g,"")
		caminho=caminho.replace(/[^\w\d\+-@:\?&=%\(\)\.]/g,"")
		caminho=caminho.replace(/([\?&])=/,"$1")
	if(caminho!="")dominio=dominio.replace(/\.+$/,"")
		v="http://"+dominio+caminho
	return v
}

/*Função que padroniza DATA*/
function data(v){
	v=v.replace(/\D/g,"") 
	v=v.replace(/(\d{2})(\d)/,"$1/$2") 
	v=v.replace(/(\d{2})(\d)/,"$1/$2") 
	return v
}

/*Função que padroniza DATA*/
function hora(v){
	v=v.replace(/\D/g,"") 
	v=v.replace(/(\d{2})(\d)/,"$1:$2")  
	return v
}

/*Função que padroniza valor monétario*/
function valor(v){
	v=v.replace(/\D/g,"") //Remove tudo o que não é dígito
	v=v.replace(/^([0-9]{3}\.?){3}-[0-9]{2}$/,"$1.$2");
	//v=v.replace(/(\d{3})(\d)/g,"$1.$2")
	v=v.replace(/(\d)(\d{2})$/,"$1,$2") //Coloca , antes dos 2 últimos digitos
	return v
}

/*Função que padroniza Area*/
function area(v){
	v=v.replace(/\D/g,"") 
	v=v.replace(/(\d)(\d{2})$/,"$1.$2") 
	return v
	
}


function reloadPage(valor, v)
{
	window.location='cadastro.php?acao=recadastra&reacao=reload&val='+valor.value+'&var='+v;
}