<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?php
/*********************************************************************

Programa: IA7.PHP
Criado em: 08/06/2010
Autor: Gustavo Moreira

Definição:
    Esse script calcula o indicador IA7

    
Cálculo:
    (Portadores de deficiência participantes da rede de assistência social e educação local que frequentam rede de saúde local) 
    / (Portadores de deficiência participantes da rede de assistência social e educação local) * 100
    

Parâmetros de Entrada (via GET):

    ...?indicador=III&granularidade=GGG&periodo=PPP
    III = no indicador, em caixa baixa, é informado o seu código
    GGG = na granularidade, em caixa baixa e sem acentuação, é informada o nome da granularidade desejada
    PPP = no periodo, em se tratando de um indicador mensal, é informado o mês e ano, no formato MM/AAAA (exs: 01/2010, 02/2010 etc)
    
    Exemplo de Entrada:
    ...?indicador=as2&granularidade=cras&periodo=01/2010
    
Saída:
    Formato do retorno
        CCC;III;G1;PPP;VVV
        CCC = código de retorno da chamada ao Calculador
        III = código do indicador retornado, em caixa baixa
        G1 = nome do grão retornado (string, pode estar acentuado e com letras maíusculas e minúsculas)
        PPP = período de referência do valor retornado
        VVV = valor retornado
        
    Exemplos de retorno:
    
        0;as2;CRAS;1;01/2010;13,2
        0;as2;CRAS;10;01/2010;10,2
        0;as2;CRAS Austin;11;01/2010;11
        

        Códigos de Retorno:

0 - Sucesso
1 - Não tenho valor
2 - Não sou eu
3 - Um ou mais Parâmetros obrigatórios faltando
4 - Um ou mais Parâmetros fora do formato esperado
5 - Granularidade invalida

*********************************************************************/

/* PARÂMETROS DE ENTRADA */
$indicador = $_GET["indicador"];
$granularidade = $_GET["granularidade"];
$periodo = $_GET["periodo"];

/* VALIDAR A ENTRADA DE DADOS */

//obrigatoriedade dos parâmetros
if (($indicador == "") || ($granularidade == "") || ($periodo == ""))
{
    echo "3";
    exit;
}

//indicador correto
if (strtoupper($indicador) != "IA7")
{
    echo "2";
    exit;
}

if (($granularidade != "município") && ($granularidade != "municipio"))
{
    echo "5";
    exit;
}

/* INICIAR CONEXÃO COM BANCO DE DADOS (CRAS) */
include "../includes/begin.php";


/* Efetuar o cálculo */
$sql = " Select 
(
    Select count(*) From
    (
    SELECT a.idpessoa FROM educacao.\"mat_alunoNecessidadeEspecial\" me
    Inner join educacao.\"mat_alunoEspecifico\" a on a.codaluno = me.cod_aluno

    Union

    Select u.idpessoa from pcni_assistenciasocial.usuario u 
    Inner join pcni_assistenciasocial.familia f on f.numerocras = u.numerocras and f.datacadastrousuario = u.datacadastrousuario 
    Where f.grauparentesco = 1 and deficienciamembrofamilia = 'S'

    ) Aux
    Where exists ( select 1 from saude.comparecimento c where c.idpessoa = aux.idpessoa)
)
/
(
    Select count(*) From
    (
    SELECT a.idpessoa FROM educacao.\"mat_alunoNecessidadeEspecial\" me
    Inner join educacao.\"mat_alunoEspecifico\" a on a.codaluno = me.cod_aluno

    Union

    Select u.idpessoa from pcni_assistenciasocial.usuario u 
    Inner join pcni_assistenciasocial.familia f on f.numerocras = u.numerocras and f.datacadastrousuario = u.datacadastrousuario 
    Where f.grauparentesco = 1 and deficienciamembrofamilia = 'S'

    ) Aux2
) * 100 as valor  ";
        

$result=pg_query($dbh, $sql);    

if ( pg_num_rows($result) == 0 )
{
    echo "1";
    exit;
}

$qt = 0;
$total = 0;

$row = pg_fetch_array($result);

$valor = round($row["valor"], 4) ;
$valor = str_replace(".",",",$valor);

//Escrever a resposta
echo "0;$indicador;Nova Iguaçu;$periodo;$valor";


/* ENCERRAR CONEXÃO COM BANCO DE DADOS */
include "../includes/end.php";

?>