<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'util.php';

define('ID_NOVA_IGUACU',330350);

class CabcomumMunicipio extends Doctrine_Record
{
	function setTableDefinition()
	{
		$this->setTableName('cabcomum.municipio');
		$this->hasColumn('id','integer', NULL, array('primary'));

		$this->hasColumn('idestado','integer', array('notnull'));
		$this->hasColumn('nome','string', 150, array('notnull'));
	}

	function validate()
	{
		trim_string_columns($this);
		$this->nome = trim($this->nome);

		$erros = array();

		if(!$this->nome)
			$erros[] = 'O nome do município deve ser preenchido';

		if(!$this->idestado)
			$erros[] = 'O estado do município deve ser preenchido';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

    function setUp()
    {
		$this->hasOne('CabcomumEstado as estado',
			array('local'=>'idestado',
			      'foreign'=>'id'));
	}
};

?>
