<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'util.php';

class CabcomumPessoaHistorico extends Doctrine_Record
{
	function setTableDefinition()
	{
		$this->setTableName('cabcomum.pessoa_historico');

		$this->hasColumn('idpessoa', 'integer', NULL, array('notnull'));
		$this->hasColumn('idsistema', 'integer', NULL, array('notnull'));
		$this->hasColumn('data_comparecimento', 'date', array('notnull'));
	}

	function validate()
	{
		trim_string_columns($this);

		if(!$this->data_comparecimento)
			$erros[] = 'A data de comparecimento deve ser informada';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

    function setUp()
    {
		$this->hasOne('CabcomumPessoa as pessoa',
			array('local'=>'idpessoa',
			      'foreign'=>'id'));

		$this->hasOne('CabcomumRefSistema as sistema',
			array('local'=>'idsistema',
			      'foreign'=>'id'));

		$this->index('idx_historico_unico',
			array('fields' 
					=> array('idpessoa','idsistema','data_comparecimento'),
				  'type' => 'unique'));
	}
};

?>
