<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'util.php';

class Ocupacao extends Doctrine_Record
{
	function setTableDefinition()
	{
		$this->setTableName('saude.ocupacao');
		$this->hasColumn('nome','string', 150, array('notblank','notnull'));
		$this->hasColumn('idgrupo', 'integer');
	}

	function validate()
	{
		trim_string_columns($this);

		if(!$this->nome)
			$erros[] = 'A descrição da ocupação deve ser preenchida';

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

    function setUp()
    {
		$this->hasOne('GrupoOcupacao as grupo',
			array('local'=>'idgrupo',
				  'foreign'=>'id'));

		$this->hasMany('OcupacaoUnidade as uso',
			array('local'=>'id',
				  'foreign'=>'idocupacao'));
	}
};

?>
