<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?

require_once 'documento.php';

class RG extends Documento
{
	function setTableDefinition()
	{
		$this->setTableName('saude.rg');
		$this->hasColumn('numero','string', 15, array('notnull','notblank'));

		$this->hasColumn('idestado', 'integer');
		$this->hasColumn('idorgao', 'integer');
		$this->hasColumn('data_emissao', 'date');

		$this->hasColumn('idpessoa', 'integer', NULL, array('notnull'));

		Documento::setTableDefinition();
	}

	function validate()
	{
		Documento::validate();

		$erros = array();

		if(!$this->numero)
			$erros[] = 'O numero do RG deve ser informado';

		if(!$this->data_emissao)
			$this->data_emissao = NULL;

		if($erros)
			throw new Exception(implode("\n",$erros));
	}

	function setUp()
	{
		Documento::setUp();

		$this->hasOne('Estado as estado',
			array('local' => 'idestado',
			      'foreign' => 'id'));
		$this->hasOne('OrgaoEmissor as orgao',
			array('local' => 'idorgao',
			      'foreign' => 'id'));

		$this->hasOne('Pessoa as pessoa',
			array('local'=>'idpessoa',
			      'foreign'=>'id'));

		$this->index('unique_rg',
			array('fields' => array('numero, idestado, idorgao'),
			      'type' => 'unique'));

		$this->index('unique_pessoa_rg',
			array('fields' => array('idpessoa, idorgao'),
			      'type' => 'unique'));
	}
};

?>
