<?PHP
/*
 * DIREITOS AUTORAIS RESERVADOS (C) 2007 UFRJ
 * 
 * ESTE PROGRAMA É SOFTWARE LIVRE; VOCÊ PODE REDISTRIBUÍ-LO E/OU MODIFICÁ-LO SOB OS
 * TERMOS DA LICENÇA PÚBLICA GERAL GNU CONFORME PUBLICADA PELA FREE SOFTWARE FOUNDATION;
 * TANTO A VERSÃO 2 DA LICENÇA, COMO (A SEU CRITÉRIO) QUALQUER VERSÃO POSTERIOR.

 * ESTE PROGRAMA É DISTRIBUÍDO NA EXPECTATIVA DE QUE SEJA ÚTIL, PORÉM, SEM NENHUMA GARANTIA;
 * NEM MESMO A GARANTIA IMPLÍCITA DE COMERCIABILIDADE OU ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA.
 * CONSULTE A LICENÇA PÚBLICA GERAL DO GNU PARA MAIS DETALHES.
 * 
 * VOCÊ DEVE TER RECEBIDO UMA CÓPIA DA LICENÇA PÚBLICA GERAL DO GNU JUNTO COM ESTE PROGRAMA; 
 * SE NÃO, ACESSE <<HTTP://WWW.GNU.ORG/LICENSES/LICENSES.PT-BR.HTML>>
 */

<?
	require_once '../common/begin.php';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>CADASTRO DE USUÁRIOS DA SAÚDE</title>

	<style type="text/css" rel='stylesheet'>
		@import "http://ajax.googleapis.com/ajax/libs/jqueryui/1.7.2/themes/ui-lightness/jquery-ui.css";
		@import "common/style.css";
	</style>

	<script type='text/javascript' src='http://www.google.com/jsapi'></script>
	<script type='text/javascript'>
		google.load('jquery','1.3');
		google.load('jqueryui','1.7');
	</script>

	<script type="text/javascript" src="js/jquery.datatables.js"> </script>
	<script type="text/javascript" src="js/jquery.blockui.js"> </script>
	<script type="text/javascript" src="js/jquery.validate.js"> </script>
	<script type="text/javascript" src="js/jquery.cookie.js"> </script>
	<script type="text/javascript" src="js/jquery.maskedinput.js"> </script>
	<script type="text/javascript" src="common/util.js"> </script>
</head>

<?
if(tem_permissao(TipoUsuario::SUPERVISOR))
	$nome_listagem = 'pessoas_supervisao';
else
	$nome_listagem = 'pessoas';
?>

<body>
<script type='text/javascript'>
	google.setOnLoadCallback(function(){

	function on_ajax_error(req, status, e)/*{{{*/
	{
		mostra_erro(erro_ajax(status, e));
		if(req.responseText)
			alert(req.responseText);
	}/*}}}*/

	listagem = $('#<?echo $nome_listagem?>').dataTable({/*{{{*/
		bJQueryUI: true,
		sPaginationType: "full_numbers",
		aaSorting: [[1,'asc']],
		bProcessing: true,
		bEscapeRegex: false,
		bServerSide: true,
		bStateSave: true,
		bFilter: true,
		sDom: '<"fg-toolbar ui-widget-header ui-corner-tl ui-corner-tr ui-helper-clearfix"lr>t<"fg-toolbar ui-widget-header ui-corner-bl ui-corner-br ui-helper-clearfix"ip>',
//		bStateSave: true,
		sAjaxSource: "common/do_list_pessoas.php",
		bAutoWidth: false,
		oLanguage: { sUrl: "lang/datatables_ptbr.json" },
		aoColumns: 
		[ 
			{
				sName: "idpessoa",
				bVisible: false
			},
			{
				sName: "nome_pessoa",
				fnRender: function(o){
					return "<a href='cadastro.php?id="+o.aData[0]+"'>"+o.aData[o.iDataColumn]+"</a>";
				},
				bUseRendered: true,
			},
			{
				sName: "nome_mae"
			},
			{
				sName: "cpf",
				bSortable: false,
				sWidth: '7em',
			},
			{
				sName: "cns",
				bSortable: false,
				sWidth: '9em',
			},
			{
<?
			if(!tem_permissao(TipoUsuario::SUPERVISOR))
				echo "bVisible: false,";
			else
				echo "bVisible: true,";
?>
				sClass: 'center',
				sName: 'situacao',
				fnRender: function(o){
					switch(o.aData[o.iDataColumn])
					{
					case 'sem_validacao':
						return "<img width=15 height=15 src='images/warning.gif'>";
					case 'validado':
						return "<img width=15 height=15 src='images/check.gif'>";
					case 'nao_validado':
						return "<img width=15 height=15 src='images/nocheck.gif'>";
					default:
						return "";
					}
				},
			},
			{
				sClass: 'center',
				sName: 'data_atualizacao',
				sWidth: '10em'
			}
		],
		fnServerData: function(src, params, callback) {
			$.blockUI({message: "<h2><img src='images/busy.gif'> Carregando informações...</h2>"});
			$.ajax({
				dataType: 'json',
				type: 'get',
				url: src,
				data: params,
				error: function(req, status, e) {
					$.unblockUI();
					on_ajax_error(req, status, e);
				},
				success: function(json){
					$.unblockUI();
					if(json.error)
						mostra_erro(json.error);
					else
						mostra_sucesso('');

					callback(json);
				}
			});
		}
	});/*}}}*/
	$.fn.dataTableExt.oPagination.iFullNumbersShowPages = 10;

	$.validator.addMethod('codigo_cns',function(value, el)
		{ return $(el).val_unmasked().length==0 || cns_valido(value); },
		'Código SUS inválido');

	$.validator.addMethod('codigo_cpf',function(value, el)
		{ return $(el).val_unmasked().length==0 || cpf_valido(value); },
		'CPF inválido');

	$('#consulta_form').validate({
		onsubmit: true,
		focusInvalid: true,
		errorClass: 'campo_erro',
		submitHandler: function(){
			var oSettings = listagem.fnSettings();

			var dados_consulta = {
				nome: $('#nome').val(),
				cpf: $('#cpf').val(),
				sus: $('#sus').val()
			};

			oSettings.aoPreSearchCols[1].sSearch = dados_consulta.nome;
			oSettings.aoPreSearchCols[3].sSearch = dados_consulta.cpf;
			oSettings.aoPreSearchCols[4].sSearch = dados_consulta.sus;

			listagem.oApi._fnFilterComplete(oSettings,
											oSettings.oPreviousSearch,1);

			$.cookie("consulta_paciente",$.toJSON(dados_consulta),{ expires:1});

			return false;
		},
		rules: {
			cpf: 'codigo_cpf',
			sus: 'codigo_cns'
		}
	});


	var dados_consulta = $.cookie("consulta_paciente");
	if(dados_consulta)
	{
		dados_consulta = $.evalJSON(dados_consulta);

		$('#nome').val(dados_consulta.nome);
		$('#cpf').val(dados_consulta.cpf);
		$('#sus').val(dados_consulta.sus);
	}

	$('#cpf').mask('999.999.999-99');
	$('#sus').mask('999 9999 9999 9999');

	});
</script>

<? 
function mostra_menu()/*{{{*/
{
	echo "<div id=menu>\n";
	if(tem_permissao(TipoUsuario::OPERADOR))
		echo "<a href='cadastro.php'>cadastrar novo paciente</a>\n";
	else
		echo "<a href='estatisticas.php'>estatísticas</a>\n";
	echo "<a href='index.php'>sair do sistema</a>\n
	</div>\n";
}/*}}}*/
include '../common/header.php';

echo "<h1>Consulta de Pacientes</h1>\n";

garante_permissao(TipoUsuario::OPERADOR, TipoUsuario::SUPERVISOR);

?>
	<div id=consulta_dialog class='dialog'>
		<h1>Pesquisa</h1>

		<form id=consulta_form>
			<div align=center id=message_box> 
				<span id=message></span> 
			</div>
			<p>
				Informe pelo menos um dos campos abaixo para filtrar/encontrar
				dados de pacientes cadastrados
			</p>
			<table>
				<tr>
					<td><label for=nome>nome:</label></td> 
					<td><input type=text id=nome name=nome size=40></td>
				</tr>
				<tr>
					<td><label for=cpf>cpf:</label></td> 
					<td><input type=text id=cpf name=cpf></td>
				</tr>
				<tr>
					<td><label for=sus>sus:</label></td> 
					<td><input type=text id=sus name=sus></td>
				</tr>
				<tr>
					<td></td>
					<td class='acoes'>
						<input type=submit value="buscar">
						<input type=reset value="limpar">
					<td>
				</tr>
			</table>
		</form>
	</div>

	<br>

	<table id=<?echo $nome_listagem?> class=listagem>
		<thead>
			<tr> 
				<th>idpessoa</th>
				<th>Nome do Paciente</th>
				<th>Nome da Mãe</th>
				<th class=ui-state-default>CPF</th>
				<th class=ui-state-default>Número SUS</th>
				<th>Situação</th>
				<th>Última Alteração</th>
			</tr>
		</thead>
		<tbody>
		</tbody>
	</table>

<?
	include '../common/footer.php';
?>

</body>

</html>
